#With priority queus

from priodict import priorityDictionary

def Dijkstra(G,start,end=None):

	D = {}	# dictionary of final distances
	P = {}	# dictionary of predecessors
	Q = priorityDictionary() # estimated distances of non-final vertices
	Q[start] = 0

	for v in Q:
		D[v] = Q[v]
		if v == end: break

		for w in G[v]:
			vwLength = D[v] + G[v][w]
			if w in D:
				if vwLength < D[w]:
					raise ValueError, "better path followed"
			elif w not in Q or vwLength < Q[w]:
				Q[w] = vwLength
				P[w] = v

	return (D,P)

def shortestPath(G,start,end):

	D,P = Dijkstra(G,start,end)
	Path = []
	while True:
		Path.append(end)
		if end == start: break
		end = P[end]
	Path.reverse()
	return Path

G = {'s': {'u':10, 'x':5},
	'u': {'v':1, 'x':2},
	'v': {'y':4},
	'x':{'v':9},
	'y':{'u':5}}

print Dijkstra(G,'s')
print shortestPath(G,'s','y')
